<?
  include_once(dirname(__FILE__) ."/include/main.php");
  $errors = array();
  
  // no user specified - redirect to user list page
  if(!getUser()) Helper::Redirect("users.php");

  if(!Helper::IsLoggedInUser()) Helper::Redirect("users.php");
  
  if($_GET["map"]) $mapID = $_GET["map"];

  foreach($_GET as $variable => $value) $$variable = stripslashes($value);
  foreach($_POST as $variable => $value) $$variable = stripslashes($value);
  
  if(isset($cancel))
  {
    Helper::Redirect("index.php?". Helper::CreateQuerystring(getUser()));
  }

  if(isset($save) || isset($delete) || isset($deleteConfirmed))
  {
    $map = new Map();
    if($mapID) 
    {
      $map->Load($mapID);
      if($map->UserID != getUser()->ID) die("Access denied");    
      $isNewMap = false;
    }
    else
    {
      $isNewMap = true;
    }
    $map->UserID = getUser()->ID;    
    $map->CategoryID = $categoryID;
    $map->Date = $date;
    $map->Name = $name; 
    $map->Organiser = $organiser;     
    $map->Country = $country;     
    $map->Discipline = $discipline;     
    $map->RelayLeg = $relayLeg;     
    $map->MapName = $mapName;
    $map->ResultListUrl = $resultListUrl;
    $map->Comment = $comment;   
  }
  else
  {
    // first page load
    if(isset($_GET["map"]))
    {
      $map = new Map();
      $map->Load($mapID);
      $isNewMap = false;
    }
    else
    {
      $map = new Map();
      $map->Date = date(__("DATE_FORMAT"));
      $map->CategoryID = getUser()->DefaultCategoryID;
      $isNewMap = true;
    }
  }
  
  if(isset($save))
  {
    // validate
    // name
    if(trim($map->Name) == "") $errors[] = __("NO_MAP_NAME_ENTERED");
    // date
    if(trim($map->Date) == "") $errors[] = __("NO_DATE_ENTERED");
    if(!strtotime($map->Date)) 
    {
      $errors[] = __("INVALID_DATE");
    }
    else
    {
      $map->Date = date("Y-m-d H:i:s", strtotime($map->Date));
    }

    // images
    $validMimeTypes = array("image/jpeg", "image/gif", "image/png");
    // map image
    $mapImageUploaded = ($_FILES["mapImage"]["tmp_name"] != "");
    if($mapImageUploaded) $mapImageInfo = getimagesize($_FILES["mapImage"]["tmp_name"]);
    if($isNewMap && !$mapImageUploaded) $errors[] = __("NO_MAP_FILE_ENTERED");
    if($mapImageUploaded && !in_array($mapImageInfo["mime"], $validMimeTypes)) $errors[] = sprintf(__("INVALID_MAP_IMAGE_FORMAT"), $_FILES["mapImage"]["name"]);
    // thumbnail image
    $thumbnailImageUploaded = ($_FILES["thumbnailImage"]["tmp_name"] != "");
    if($thumbnailImageUploaded) $thumbnailImageInfo = getimagesize($_FILES["thumbnailImage"]["tmp_name"]);
    if($thumbnailImageUploaded && !in_array($thumbnailImageInfo["mime"], $validMimeTypes)) $errors[] = sprintf(__("INVALID_THUMBNAIL_IMAGE_FORMAT"), $_FILES["thumbnailImage"]["name"]);
    
    if(count($errors) == 0)
    {
      $map->LastChangedTime = date("Y-m-d H:i:s"); 
      $map->Save();
      $thumbnailCreatedSuccessfully = false;
      $error = "";
      if(!DataAccess::SaveMapAndThumbnailImage($map, $_FILES["mapImage"], $_FILES["thumbnailImage"], $error, $thumbnailCreatedSuccessfully))
      {
        if($error == "couldNotUploadMapImage") $errors[] = sprintf(__("MAP_IMAGE_COULD_NOT_BE_UPLOADED"), $_FILES["mapImage"]["name"]);  
        if($error == "couldNotUploadThumbnailImage") $errors[] = sprintf(__("THUMBNAIL_IMAGE_COULD_NOT_BE_UPLOADED"), $_FILES["thumbnailImage"]["name"]);  
      }
      
      if(!$mapID)
      {
        Helper::LogUsage("addMap", "user=". urlencode(getUser()->Username) ."&map=". $map->ID);
      }

      if(count($errors) == 0) Helper::Redirect("index.php?". Helper::CreateQuerystring(getUser()) . (!$thumbnailCreatedSuccessfully ? "&error=thumbnailCreationFailure" : ""));
    }
  }
  elseif(isset($deleteConfirmed))
  {
    DataAccess::DeleteMap($map);
    Helper::Redirect("index.php?". Helper::CreateQuerystring(getUser()));
  }

  $title = ($mapID ? sprintf(__("EDIT_MAP_X"), $map->Name) : __("ADD_MAP"));
?>
<?php print '<?xml version="1.0" encoding="UTF-8"?>'; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<link rel="stylesheet" href="style.css" type="text/css" />
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<title><?=__("PAGE_TITLE")?> :: <?=$title?></title>
<link rel="icon" type="image/png" href="gfx/favicon.png" />
<script type="text/javascript" src="js/prototype/prototype_1.6.0.3.js"></script>
<script type="text/javascript">
function showTooltip(control, visible)
{
  var tooltip = $(control.id + '_tooltip');
  if(!visible && !tooltip.hasClassName('hidden')) tooltip.addClassName('hidden');
  if(visible && tooltip.hasClassName('hidden')) tooltip.removeClassName('hidden');
}
</script>
</head>

<body id="editMapBody">
<div id="wrapper">
<? Helper::CreateTopbar() ?>
<div id="content">
<form class="wide" method="post" action="<?=$_SERVER["PHP_SELF"]?>?<?=Helper::CreateQuerystring(getUser(), $mapID)?>" enctype="multipart/form-data">

<h1><?=$title?></h1>

<? if(count($errors) > 0) { ?>
<ul class="error">
<?
  foreach($errors as $e)
  {
    print "<li>$e</li>";
  }
?>
</ul>
<? } ?>

<div class="container">
<label for="categoryID"><?=__("CATEGORY")?></label>
<select name="categoryID" id="categoryID" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" >
<?
  $categories = getUser()->GetCategories();
  foreach($categories as $c)
  {
    print '<option value="'. $c->ID .'"'. ($c->ID == $map->CategoryID ? ' selected="selected"' : '') .'>'. $c->Name .'</option>';  
  }
?>
</select>
<div class="tooltip hidden" id="categoryID_tooltip"><?=__("CATEGORY_TOOLTIP")?></div> 
</div>

<div class="container">
<label for="date"><?=__("DATE")?></label>
<?
  if(date("H:i:s", strtotime($map->Date)) == "00:00:00") $map->Date = date("Y-m-d", strtotime($map->Date));
?>
<input type="text" class="text" name="date" id="date" value="<?=hsc($map->Date)?>" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);" />
<div class="tooltip hidden" id="date_tooltip"><?=__("MAP_DATE_FORMAT")?></div> 
</div>

<div class="container">
<label for="name"><?=__("NAME")?></label>
<input type="text" class="text" name="name" id="name" value="<?=hsc($map->Name)?>" />
</div>

<? if(__("SHOW_MAP_AREA_NAME")) { ?>
<div class="container">
<label for="relayLeg"><?=__("MAP_AREA_NAME")?></label>
<input type="text" class="text" name="mapName" id="mapName" value="<?=hsc($map->MapName)?>" />
</div>
<? } ?>

<? if(__("SHOW_ORGANISER")) { ?>
<div class="container">
<label for="organiser"><?=__("ORGANISER")?></label>
<input type="text" class="text" name="organiser" id="organiser" value="<?=hsc($map->Organiser)?>" />
</div>
<? } ?>

<? if(__("SHOW_COUNTRY")) { ?>
<div class="container">
<label for="country"><?=__("COUNTRY")?></label>
<input type="text" class="text" name="country" id="country" value="<?=hsc($map->Country)?>" />
</div>
<? } ?>

<? if(__("SHOW_DISCIPLINE")) { ?>
<div class="container">
<label for="discipline"><?=__("DISCIPLINE")?></label>
<input type="text" class="text" name="discipline" id="discipline" value="<?=hsc($map->Discipline)?>" />
</div>
<? } ?>

<? if(__("SHOW_RELAY_LEG")) { ?>
<div class="container">
<label for="relayLeg"><?=__("RELAY_LEG_LONG")?></label>
<input type="text" class="text" name="relayLeg" id="relayLeg" value="<?=hsc($map->RelayLeg)?>" />
</div>
<? } ?>

<? if(__("SHOW_RESULT_LIST_URL")) { ?>
<div class="container">
<label for="relayLeg"><?=__("LINK_TO_RESULT_LIST")?></label>
<input type="text" class="text" name="resultListUrl" id="resultListUrl" value="<?=hsc($map->ResultListUrl)?>" />
</div>
<? } ?>

<? if(__("SHOW_COMMENT")) { ?>
<div class="container">
<label for="comment"><?=__("COMMENT")?></label>
<textarea name="comment" id="comment" rows="5" cols="60"><?=hsc($map->Comment)?></textarea>
</div>
<? } ?>

<div class="container">
<label for="mapImage"><?=__("MAP_IMAGE_FILE")?></label>
<input type="file" name="mapImage" id="mapImage"<? if($mapID) print 'onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);"';?> />
<? if($mapID) print '<div class="tooltip hidden" id="mapImage_tooltip">'. __("LEAVE_EMPTY_TO_KEEP_EXISTING_MAP") .'</div>'; ?> 
</div>

<div class="container">
<label for="thumbnailImage"><?=__("THUMBNAIL_IMAGE_FILE")?></label>
<input type="file" name="thumbnailImage" id="thumbnailImage" onfocus="showTooltip(this, true);" onblur="showTooltip(this, false);"  />
<div class="tooltip hidden" id="thumbnailImage_tooltip"><? printf(__("THUMBNAIL_INFO"), THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT); ?></div> 
</div>

<div class="buttons">
<input type="submit" class="submit" name="save" id="save" value="<?=__("SAVE")?>" />
<? if(!isset($delete)) { ?>
<input type="submit" class="submit" name="delete" id="delete" value="<?=__("DELETE")?>" />
<? } else { ?>
<input type="submit" class="submit" name="deleteConfirmed" id="delete" value="<?=__("CONFIRM_DELETION")?>" />
<? } ?>
<input type="submit" class="submit" name="cancel" id="cancel" value="<?=__("CANCEL")?>" />
</div>

</form>
</div>
</div>
</body>
</html>